"""Add user role

Revision ID: bfd00f68cc3e
Revises: 8e53629eb561
Create Date: 2023-09-29 10:26:01.815915

"""
from typing import Sequence, Union

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision: str = "0401993f0576"
down_revision: Union[str, None] = "8e53629eb561"
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    userrole_enum = postgresql.ENUM(
        "user", "moderator", "admin", name="user_role", create_type=False
    )
    userrole_enum.create(op.get_bind(), checkfirst=True)

    op.add_column(
        "user", sa.Column("role", userrole_enum, server_default="user", nullable=False)
    )
    op.alter_column(
        "user",
        "is_active",
        existing_type=sa.BOOLEAN(),
        server_default=sa.text("false"),
        existing_nullable=False,
    )
    op.create_index(op.f("ix_user_role"), "user", ["role"], unique=False)
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f("ix_user_role"), table_name="user")
    op.alter_column(
        "user",
        "is_active",
        existing_type=sa.BOOLEAN(),
        server_default=None,
        existing_nullable=False,
    )
    op.drop_column("user", "role")
    # ### end Alembic commands ###
